
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Visual Basic快捷教程——流程控制 / 憋错料</title>

    <meta name="description" content="Visual Basic快捷教程——流程控制 美籍匈牙利数学家冯·诺依曼于1946年提出&quot;程序存储,顺序执行&quot;的观念,为现代计算机奠定了重要基础.这一观点认为:应该把程序本身当作数据来对待,程序和该程序处理的数据用同样的方式储存.电子计算机的数制宜采用二进制:计算机应该按照程序顺序执行.所以现在开发人员在编写的程序代码时,其实都隐含地认为计算机将来会一行一行按顺序来执行这些指令.但是在顺序执行的过程中,有时我们希望计算机根据条件判断来选择性地执行(或者不执行)一些代码--这时就需要用到选择结构(或称分支结构).另外一些时 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Visual Basic快捷教程——流程控制</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>美籍匈牙利数学家冯·诺依曼于1946年提出“程序存储，顺序执行”的观念，为现代计算机奠定了重要基础。这一观点认为：应该把程序本身当作数据来对待，程序和该程序处理的数据用同样的方式储存。电子计算机的数制宜采用二进制；计算机应该按照程序顺序执行。所以现在开发人员在编写的程序代码时，其实都隐含地认为计算机将来会一行一行按顺序来执行这些指令。但是在顺序执行的过程中，有时我们希望计算机根据条件判断来选择性地执行（或者不执行）一些代码——这时就需要用到选择结构（或称分支结构）。另外一些时候，我们希望计算机能够（有条件地）重复地执行某一段代码——这时就需要用到循环结构。</p>
<p>这里所说的顺序执行、选择结构，以及循环结构统称为程序的流程控制。本文主要介绍在Visual Basic中与流程控制有关的一些语法规则。顺序执行是程序执行的默认规则，本文对此将不多赘述。</p>
<p><strong>一、选择结构</strong></p>
<p>Visual Basic中用来实现选择结构的方式包括：If、Select/Case、Switch、Choose等4这种。</p>
<p><strong>1. If 语句</strong></p>
<p>基于 If 语句实现的选择结构主要有三种形式：</p>
<ul>
<li>If ... Then ...</li>
<li>If ... Then ... Else ...</li>
<li>If ... ElseIf ... Else ...</li>
</ul>
<p>下面我们逐个详解。</p>
<p>1）If ... Then ... 是属于单向选择结构，它会潘丹条件表达式（condition）是否为真，若条件表达式为真，则会执行该分支的语句块（statements）；否则，就不执行任何操作。Visual Basic中If ... Then ...的语法规则如下：</p>
<pre>If 条件表达式 Then
    语句块
End If</pre>
<p>下面通过一个判定用户是否要退出程序的例子来演示 If ... Then ... 在实际中的使用。</p>
<pre>Public Class Form1

    Private Sub Button_Exit_Click(sender As Object, e As EventArgs) Handles Button_Exit.Click

        Dim Result As MsgBoxResult
        Result = Interaction.MsgBox(&quot;您确定要退出本程序吗？&quot;, vbOKCancel+vbQuestion, &quot;提示&quot;)

        If Result = vbOK Then
            End
        End If

    End Sub

End Class
</pre>
<p>执行上述代码，所得之结果如下所示。当用户单击【退出程序】按钮时，程序会弹出一个消息对话框询问用户是否真的要退出程序。如果用户选择【确定】，那么程序将随机退出。如果用户选择【取消】，程序将继续执行。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDIwMjEzNTgxNzY=.jpg" /></p>
<p>2）If ... Then ... Else 是一种双向选择结构，它会判断条件表达式是否为真，如果条件表达式为真，则程序会执行为真的分支语句块。否则若条件表达式为假，那么程序便会执行为假的分支语句块。Visual Basic中If ... Then ... Else 的语法规则如下：</p>
<pre>If 条件表达式 Then
    条件表达式为真的语句块
Else
    条件表达式为假的语句块
End If</pre>
<p>下面通过一个判定用户输入的年份是否为闰年的示例程序来演示 If ... Then ... Else  在实际中的使用。</p>
<pre>Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        If TextBox_Year.Text Mod 4 = 0 Then
            MsgBox(&quot;公元&quot; + TextBox_Year.Text + &quot;年是闰年。&quot;,
                   MsgBoxStyle.OkOnly + MsgBoxStyle.Information, &quot;判定结果&quot;)
        Else
            MsgBox(&quot;公元&quot; + TextBox_Year.Text + &quot;年不是闰年。&quot;,
                   MsgBoxStyle.OkOnly + MsgBoxStyle.Information, &quot;判定结果&quot;)
        End If

    End Sub
End Class</pre>
<p>执行上述代码，所得之结果如下所示。如果用户输入的年份确实为闰年，那么随后弹出的消息对话框就会反馈说这一年确实是闰年。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDIwMjI1MTQwNjc=.jpg" /></p>
<p>否则如果用户输入的年份不是闰年，那么随后弹出的消息对话框就会反馈说这一年并非是闰年。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDIwMjI1MDI5MzU=.jpg" /></p>
<p>3）If ... ElseIf ... Else 是一种多重嵌套选择结构，当紧跟在 If 后面的判断条件为假时，程序再多做一次判定，即执行ElseIf后面的判定。而且ElseIf后面还可以嵌套多层ElseIf判断。如果所有的判断条件都为假时，那么程序才会执行Else后面的分支语句块。Visual Basic中If ... ElseIf ... Else 的（多重嵌套判断）语法规则如下：</p>
<pre>If 第1次条件判断表达式 Then
    第1次条件判断表达式为真的语句块
ElseIf 第2次条件判断表达式 Then
    第2次条件判断表达式为真的语句块

... ...

ElseIf 第n次条件判断表达式 Then
    第n次条件判断表达式为真的语句块
Else
    当前n次判断条件表达式都为假时所执行的语句块
End If</pre>
<p>下面通过一个多项选择题小测验程序的例子来演示基于ElseIf ... Else 的多重嵌套选择结构在实际中的使用。</p>
<pre>Public Class Form1

    Private Sub Button_Submit_Click(sender As Object, e As EventArgs) Handles Button_Submit.Click

        If CheckBox_A.Checked Then
            MsgBox(&quot;很遗憾！答错了。&quot;, MsgBoxStyle.Critical, &quot;判定结果&quot;)
        ElseIf CheckBox_B.Checked Xor CheckBox_C.Checked Then
            MsgBox(&quot;还差一点！加油。&quot;, MsgBoxStyle.Critical, &quot;判定结果&quot;)
        ElseIf CheckBox_B.Checked And CheckBox_C.Checked Then
            MsgBox(&quot;恭喜你！答对了。&quot;, MsgBoxStyle.Information, &quot;判定结果&quot;)
        Else
            MsgBox(&quot;你还没有做出选择哦~&quot;, MsgBoxStyle.Exclamation, &quot;提示&quot;)
        End If

    End Sub
End Class</pre>
<p>执行上述代码，所得之结果如下所示。只有当用户给出正确的选择答案时，程序才会判定回答正确。其他执行结果请自行测试，此处略去。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDIxNzE1NTg2NzQ=.jpg" /></p>
<p>4） 最后我们还要补充一种基于 IIf 函数的双向选择结构。这其实非常类似C语言中的三元运算符“: ?”。IIf 函数选择结构的语法规则如下：</p>
<pre>IIf(Expression, TruePart, FalsePart)</pre>
<p>其中表达式（Expression）最终的结果为布尔型，TruePart 与 FalsePart 均为对象类型。其规则如下：</p>
<ul>
<li>假如表达式为真，则返回真时的对象。</li>
<li>假如表达式为假，则返回假时的对象。</li>
</ul>
<p>可见基于IIf 函数选择结构会判断表达式是否为真，并据此选择要返回的对象。而且因为其返回类型是对象，所以返回值可以包含各种数据类型，如数字，字符串或布尔类型等等。</p>
<p>下面我们用基于IIf 函数选择结构来重写前面的用于判断年份是否为闰年的程序，代码如下：</p>
<pre>Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        MsgBox(IIf(TextBox_Year.Text Mod 4 = 0,
                   &quot;公元&quot; + TextBox_Year.Text + &quot;年是闰年。&quot;, &quot;公元&quot; + TextBox_Year.Text + &quot;年不是闰年。&quot;),
               MsgBoxStyle.OkOnly + MsgBoxStyle.Information, &quot;判定结果&quot;)

    End Sub
End Class</pre>
<p>执行上述程序将会得到与之前一样的结果，这里不再赘述。</p>
<p>此外，如果在IIf 的函数中又包含有IIf 函数，便可以形成嵌套的选择结构，从而实现更加复杂的分支判断条件。例如下面这个示例程序。</p>
<pre>Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        MsgBox(&quot;您要的是一杯&quot; +
            IIf(RButton_Milk_Y.Checked, IIf(RButton_Suger_Y.Checked, &quot;加奶加糖&quot;, &quot;加奶不加糖&quot;),
                IIf(RButton_Suger_N.Checked, &quot;不加奶不加糖&quot;, &quot;不加奶加糖&quot;)) + &quot;的咖啡。&quot;,
            vbInformation, &quot;您的选择&quot;)

    End Sub
End Class</pre>
<p>执行上述代码，所得之结果如下所示。其他执行结果请自行测试，此处略去。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDIyMzMzMTg3MTc=.jpg" /></p>
<p><strong>2. Select... Case语句</strong></p>
<p>Select ... Case 是仍然是属于多重选择的结构。Select后面跟着的一个选择条件，不同的Case后面跟的是选择条件可能满足的取值。当某个Case后面跟的可能取值刚好满足选择条件时，就执行对应的语句块。Select ... Case 与If ... Then... Else的作用很相似，但是当判断条件超多3个时，通常使用Select ... Case会比较方便。</p>
<p>基于Select ... Case的选择结构一般采用如下语法形式：</p>
<pre>Select
    Case 条件1
        语句块1
    Case 条件2
        语句块2
... ...

    Case 条件n
        语句块n
    Case Else
        当Case Else之前的Case条件都不成立时所执行的语句块
End Select</pre>
<p>其中Case Else部分也可以省略，但为了程序的鲁棒性，通常会设置一个缺省条件。</p>
<p>下面这个程序演示了使用Select ... Case 的一般方法。</p>
<pre>Public Class Form1

    Dim pic_Aston As Image = Image.FromFile(Application.StartupPath &amp; &quot;\pic\Aston.jpg&quot;)
    Dim pic_Holden As Image = Image.FromFile(Application.StartupPath &amp; &quot;\pic\Holden.jpg&quot;)
    Dim pic_Jeep As Image = Image.FromFile(Application.StartupPath &amp; &quot;\pic\Jeep.jpg&quot;)
    Dim pic_Hyundai As Image = Image.FromFile(Application.StartupPath &amp; &quot;\pic\Hyundai.jpg&quot;)
    Dim pic_Lucid As Image = Image.FromFile(Application.StartupPath &amp; &quot;\pic\Lucid.jpg&quot;)

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Select Case ComboBox1.Text
            Case &quot;Aston Martin Vanquish S&quot;
                PictureBox_Car.Image = pic_Aston
            Case &quot;Holden Commodore&quot;
                PictureBox_Car.Image = pic_Holden
            Case &quot;Jeep Grand Cherokee&quot;
                PictureBox_Car.Image = pic_Jeep
            Case &quot;Hyundai Santa Fe&quot;
                PictureBox_Car.Image = pic_Hyundai
            Case &quot;Lucid Air&quot;
                PictureBox_Car.Image = pic_Lucid
        End Select

    End Sub
End Class</pre>
<p>执行上述代码，所得之结果如下所示。当用户选择不同的车型时，右侧的图像框就会展示对应的图片。上面的程序中我们并没有设置缺省选项，读者可以试着加上一个缺省选项。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDIyMTQ0MTI4Mjk=.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDIyMTQ0MjE1OTU=.jpg" /></p>
<p>这里需要提醒读者注意的是，Select ... Case本质上是等同于If ... Then... Else的一种分支结构。既然是分支结构，我们就应该保证各个分支条件之间不能相互包含。因为在Select ... Case的结构中，如果分支选择被多个Case后面带的条件所满足，它也仅会执行第一次满足条件的Case对应的语句块。例如下面这个例子：</p>
<pre>Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim value As Double
        value = TextBox1.Text

        Select Case value
            Case Is &gt; 1000
                MsgBox(&quot;您输入的数大于1000.&quot;)
            Case Is &gt; 100
                MsgBox(&quot;您输入的数大于100.&quot;)
            Case Is &gt; 0
                MsgBox(&quot;您输入的数大于0.&quot;)
            Case Else
                MsgBox(&quot;您输入的是一个负数.&quot;)
        End Select

    End Sub
End Class</pre>
<p>显然一个大于1000的数也必然会大于100和0，但是你执行程序并在文本框中输入1999时，也只会得出下图所示之结果。因为当第一个Case使得分支条件得以满足时，后续若干Case所带的判断就都不会被执行。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDMwMDE5Mjk2ODk=.jpg" /></p>
<p><strong>3. Switch语句</strong></p>
<p>Switch（在Visual Basic中使用时应该写为Microsoft.VisualBasic.Switch）属于多重选择结构。它的作用与Select ... Case非常类似，但是代码会更为精简。其语法规则如下：</p>
<pre>Microsoft.VisualBasic.Switch(表达式1, 结果1, _
    表达式2, 结果2, _
    ... ...
    表达式n, 结果n)</pre>
<p>若表达式1判断为真，则返回结果1；若表达式2判断为真，则返回结果2；以此类推，表达式n判断为真，则返回结果n。其返回结果的类型为对象，所以返回值可以包含各种数据类型，例如数值、字符或布尔类型等等。</p>
<p>下面这个例子演示了用Switch语句重写上面的汽车图库小程序，注意其中略去了定义及载入图片文件的部分代码（因为这部分代码与之前用到过的并无差别）。可见，利用Switch语句，我们的代码得以更加精简。</p>
<pre>Public Class Form1

    ‘此处代码有省略，可参考之前用于载入图像的代码

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        PictureBox_Car.Image = Microsoft.VisualBasic.Switch(
            ComboBox1.Text = &quot;Aston Martin Vanquish S&quot;, pic_Aston, _
            ComboBox1.Text = &quot;Holden Commodore&quot;, pic_Holden, _
            ComboBox1.Text = &quot;Jeep Grand Cherokee&quot;, pic_Jeep, _
            ComboBox1.Text = &quot;Hyundai Santa Fe&quot;, pic_Hyundai, _
            ComboBox1.Text = &quot;Lucid Air&quot;, pic_Lucid)

    End Sub
End Class</pre>
<p>上述代码的执行结果与前图所示一致，这里不再赘述。</p>
<p><strong>4. Choose语句</strong></p>
<p>Choose（在Visual Basic中使用时应该写为Microsoft.VisualBasic.Choose）属于多重选择结构。它主要根据索引值（Index）来选择并返回从参数列表中的对象。它的语法规则如下：</p>
<pre>Microsoft.VisualBasic.Choose(Index, 对象1, 对象2, ..., 对象n)</pre>
<p>Choose 函数将从对象参数列表“对象1, 对象2, ..., 对象n”中，根据Index 的值，返回列表中的指定成员。 选择列表的第一个成员时 Index 为 1。 如果 Index 超出这些限制 Choose 返回 Nothing。如果 Index 不是整数，它将被舍入为最接近的整数作为索引。</p>
<p>下面这个例子演示里用Choose语句重写上面的汽车图库小程序，注意其中略去了定义及载入图片文件的部分代码（因为这部分代码与之前用到过的并无差别）。可见，利用Choose语句，与之前的代码相比，现在的版本变得更加精简。</p>
<pre>Public Class Form1

    ‘此处代码有省略，可参考之前用于载入图像的代码

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        PictureBox_Car.Image = Microsoft.VisualBasic.Choose(ComboBox1.SelectedIndex + 1,
                                     pic_Aston, pic_Holden, pic_Jeep, pic_Hyundai, pic_Lucid)

    End Sub
End Class</pre>
<p>上述代码的执行结果与前图所示一致，这里不再赘述。</p>
<p><strong>二、循环结构</strong></p>
<p><strong><br /></strong></p>
<p>Visual Basic中用于实现循环结构的方式主要有For、While、Loop等3种<strong>。</strong>此外本部分内容还涉及一些用于跳槽循环的关键字。<strong><br /></strong></p>
<p><strong><br /></strong></p>
<p><strong>一、For语句<br /></strong></p>
<p>For 循环结构主要形式有以下两种：</p>
<ul>
<li>For ... Next</li>
<li>For Each ... Next<strong><br /></strong></li>
</ul>
<p>下面我们逐个详解。<strong><br /></strong></p>
<p>1）For ... Next 是最常用的一般循环语句。它主要通过设计计数器（Counter）的起始值、终止值和递增值三个部分，来决定循环执行的规则与次数。在正常的执行的情况下，只有当计数器的值等于“终止值”时，才会跳出循环。<strong><br /></strong></p>
<p>For ... Next的语法规则如下：<strong><br /></strong></p>
<p><strong></strong></p>
<pre>For 计数器变量（counter）As 数据类型 = 起始值 To 终止值 Step 递增值
    语句块（statements）
Next i</pre>
<p>下面这个示例程序演示了使用For ... Next 循环结构的基本方法。这个程序实现了一个简单的幻灯片放映功能。<strong><br /></strong></p>
<p><strong></strong></p>
<pre>Public Class Form1

    ‘此处代码有省略，可参考之前用于载入图像的代码

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim index As Integer
        Static start As Single
        Button1.Enabled = False

        For index = 1 To 5 Step 1
            PictureBox_Car.Image = Microsoft.VisualBasic.Choose(index,
                                             pic_Aston, pic_Holden, pic_Jeep, pic_Hyundai, pic_Lucid)

            start = Microsoft.VisualBasic.Timer()
            Do While Microsoft.VisualBasic.Timer() &lt; start + 2
                System.Windows.Forms.Application.DoEvents()
            Loop
        Next

        Button1.Enabled = True

    End Sub
End Class</pre>
<p>执行上述代码，所得之结果如下所示。当用户单击【放映幻灯片】按钮后，图像对话框中将以2秒为间隔的速度逐个播放图库中的图片。</p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDMxNDU4NTExOTI=.jpg" /><br /></strong></p>
<p>2）For Each ... Next 是在一个集合中针对其中的每一个元素逐个执行的循环结构。这种语法在Python中也有类似的实现。它的处理对象通常是数组、对象集合等，通过For Each来取出集合中的单个元素（或对象）。在正常情况下，当集合中每一个对象都被取出时，才会跳出循环。其语法规则如下：</p>
<pre>For Each 对象变量 As 数据类型 In 集合数组
    语句块（statements）
Next 对象变量</pre>
<p>下面这个例子演示了用For Each ... Next 语句重写上面的幻灯片放映小程序，注意其中略去了定义及载入图片文件的部分代码（因为这部分代码与之前用到过的并无差别）。</p>
<p><strong></strong></p>
<pre>Public Class Form1

     ‘此处代码有省略，可参考之前用于载入图像的代码

    Dim pics() As Image = {pic_Aston, pic_Holden, pic_Jeep, pic_Hyundai, pic_Lucid}

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Static start As Single
        Button1.Enabled = False

        For Each pic As Image In pics

            PictureBox_Car.Image = pic

            start = Microsoft.VisualBasic.Timer()
            Do While Microsoft.VisualBasic.Timer() &lt; start + 2
                System.Windows.Forms.Application.DoEvents()
            Loop
        Next

        Button1.Enabled = True

    End Sub
End Class</pre>
<p>上述代码的执行结果与前图所示一致，这里不再赘述。</p>
<p><strong><br /></strong></p>
<p><strong>二、While语句</strong></p>
<p>以While为基础的循环结构，主要根据条件表达式（condition）的值来判断是否跳出循环，若条件表达式为真，则会继续执行循环体中的语句段，否则若条件表达式为假，则跳出循环。与For结构不同，While结构不需要确定循环所需执行的次数，只要知道结束条件即可。While结构的基本语法规则如下：</p>
<pre>While 条件表达式（condition）
    语句块（statements）
End While</pre>
<p>下面这个例子演示了While结构的基本使用方法。该示例程序的作用是统计某段文本中特定单词出现的次数。</p>
<pre>Public Class Form1

    Dim str As String = &quot;Pick up one basketball from the basket which contains basketballs.&quot;
    Dim subStr As String = &quot;basket&quot;

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim counter As Integer
        Dim pos As Integer = str.IndexOf(subStr)
        counter = 0

        While pos &gt; 0
            counter += 1
            pos = str.IndexOf(subStr, pos + 1)
        End While

        MsgBox(&quot;The word ‘&quot; &amp; subStr &amp; &quot;‘ is found &quot; &amp; counter.ToString &amp; &quot; times.&quot;)

    End Sub
End Class</pre>
<p>执行上述代码，所得之结果如下所示。当用户单击【计数】按钮时，程序会统计出指定单词在文段中出现的次数。应该注意到循环继续执行的条件是仍然可以找到新出现的指定单词，言下之意也就是如果指定单词已经找不到了就可以结束循环了。<br />
<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDMyMDUxMDQ5NDE=.jpg" /></p>
<p><p><strong>三、Loop语句</strong></p>
<p>Loop循环结构主要形式大致可以分为如下四种：</p>
<ul>
<li>Do Until ... Loop（条件表达式不成立时才会进入循环，循环不一定会执行）</li>
<li>Do While ... Loop（条件表达式成立时才会进入循环，循环不一定会执行）</li>
<li>Do ... Loop Until（条件表达式不成立时才会进入循环，循环至少会执行一次）</li>
<li>Do ... Loop While（条件表达式成立时才会进入循环，循环至少会执行一次）</li>
</ul>
<p>下面我们逐个详解。</p>
<p>1）Do Until ... Loop 属于循环结构中的“前测试循环”，即当条件表达式（condition）不成立时，才会进入循环体执行语句块。其语法规则如下：</p>
<pre>Do Until 条件表达式（condition）
    语句块（statements）
Loop</pre>
<p>下面这个例子演示了Do Until ... Loop 结构的基本使用方法。该示例程序的作用是求使得前n项自然数之和不大于某个预设上限的最大之n值。</p>
<pre>Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim upperBound As Integer

        Try
            upperBound = TxtBox_upbound.Text
        Catch ex As Exception
            MsgBox(&quot;请在文本框中输入一个正整数作为求和的上限!&quot;, vbExclamation, &quot;提示&quot;)
            Return
        End Try

        Dim sum As Integer = 0
        Dim num As Integer = 0

        Do Until sum &gt; upperBound
            num += 1
            sum += num
        Loop

        MsgBox(&quot;使得前n项自然数之和不大于&quot; &amp; upperBound.ToString &amp; &quot;的最大之n为&quot; &amp; (num - 1).ToString)

    End Sub
End Class</pre>
<p>执行上述代码，所得之结果如下所示。注意到本例还使用了Visual Basic中的异常处理机制来规避用户误输入上限值时可能引起的问题。<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDMyMzUyMTY1MTk=.jpg" /></p>
<p>2）Do While ... Loop 依然属于循环结构中的“前测试循环”，但与Do Until ... Loop 结构相反，使用Do While ... Loop时只有当条件表达式（condition）成立时，才会进入循环体执行语句块。其语法规则如下：</p>
<pre>Do While 条件表达式（condition）
    语句块（statements）
Loop</pre>
<p>这里同样采用前面“求使得前n项自然数之和不大于某个预设上限的最大之n值”问题来作为示例。易见，由于Do While ... Loop和Do Until ... Loop的循环执行条件是相反的。所以两个程序的唯一不同就在于把之前的条件表达式“sum &gt; upperBound”改成了“sum &lt;= upperBound”。</p>
<pre>Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim upperBound As Integer

        Try
            upperBound = TxtBox_upbound.Text
        Catch ex As Exception
            MsgBox(&quot;请在文本框中输入一个正整数作为求和的上限!&quot;, vbExclamation, &quot;提示&quot;)
            Return
        End Try

        Dim sum As Integer = 0
        Dim num As Integer = 0

        Do While sum &lt;= upperBound
            num += 1
            sum += num
        Loop

        MsgBox(&quot;使得前n项自然数之和不大于&quot; &amp; upperBound.ToString &amp; &quot;的最大之n为&quot; &amp; (num - 1).ToString)

    End Sub
End Class</pre>
<p>上述代码的执行结果与前图所示一致，这里不再赘述。</p>
<p>3）Do ... Loop Until 属于循环结构中的“后测试循环”，“后测试循环”的特点是不论条件表达式是否为真，循环都会至少被执行一次。从关键字“Until”中，想必读者也能猜到，该种语句表示只有当表达式不成立时，才会继续执行循环体中的语句段。Do ... Loop Until的语法规则如下：</p>
<pre>Do
    语句块（statements）
Loop Until 条件表达式（condition）</pre>
<p>下面仍然以之前给出的“统计某段文本中特定单词出现次数”问题为例来编写示例程序，从中读者可以清晰地了解到使用Do ... Loop Until 语句的基本方法。</p>
<pre>Public Class Form1

    Dim str As String = &quot;Pick up one basketball from the basket which contains basketballs.&quot;
    Dim subStr As String = &quot;basket&quot;

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim counter As Integer = 0
        Dim pos As Integer = -1

        Do
            pos = str.IndexOf(subStr, pos + 1)
            If pos &lt;&gt; -1 Then
                counter += 1
            End If
        Loop Until (pos = -1)

        MsgBox(&quot;The word ‘&quot; &amp; subStr &amp; &quot;‘ is found &quot; &amp; counter.ToString &amp; &quot; times.&quot;)

    End Sub
End Class</pre>
<p>上述代码的执行结果与前图所示一致，这里不再赘述。</p>
<p>4）Do ... Loop While 依然属于循环结构中的“后测试循环”，即不论条件表达式是否为真，循环都会至少被执行一次。但与Do ... Loop Until 不同，使用Do ... Loop While 时只有当条件表达式（condition）成立时，才会继续执行循环体中的语句段。Do ... Loop While 的语法规则如下：</p>
<pre>Do
    语句块（statements）
Loop While 条件表达式（condition）</pre>
<p>下面我们通过一个例子来演示Do ... Loop While结构的用法。这个例子实现了基于欧几里得算法（又称辗转相除法）求解最大公因数的功能。</p>
<pre>Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim v1 As Integer = TextBox_v1.Text
        Dim v2 As Integer = TextBox_v2.Text
        Dim tmp As Integer

        Do
            tmp = v1 Mod v2
            v1 = v2
            v2 = tmp
        Loop While (v2 &lt;&gt; 0)

        MsgBox(&quot;A与B的最大公因数=&quot; &amp; v1)
    End Sub
End Class</pre>
<p>执行上述代码，所得之结果如下所示。当用户输入两个整数，并单击【求最大公因数】按钮后，程序将在弹出的消息对话框中给出这两个整数的最大公因数。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDMyMjE4MDQyNDg=.jpg" /></p>
<p><strong>四、Continue语句</strong></p>
<p>现在大家所熟知的高级语言（例如C、C++、Python等）一般都提供有continue关键字，Visual Basic也不例外。它可以在执行循环时增加更多的逻辑变化，使得循环体完成更加复杂的功能。具体而言，当执行一个循环体时，如果遇到</p>
<p>continue语句，那么程序就是终止本次循环执行（也就是不再执行循环体中位于continue之后的语句段），继而进入下一轮循环的执行。Continue语句的基本语法规则如下：</p>
<pre>Continue {Do | For | While}</pre>
<p>例如在下面这个程序中，Students数组中每个数组元素都表示的一名学生的信息，每名学生的信息是一个二元组，包含其性别和身高。程序根据用户的指令来选择计算男生的平均身高或者女生的平均身高。因为使用了continue语句，所以在遍历整个数组时，对于性别不符合的元素，程序就会跳过不予计算。</p>
<pre>Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim Students() As Tuple(Of String, Integer) = {Tuple.Create(&quot;M&quot;, 180),
                Tuple.Create(&quot;M&quot;, 175), Tuple.Create(&quot;F&quot;, 165), Tuple.Create(&quot;M&quot;, 183),
                Tuple.Create(&quot;M&quot;, 178), Tuple.Create(&quot;F&quot;, 168), Tuple.Create(&quot;F&quot;, 171)}

        Dim sum As Integer = 0
        Dim num As Integer = 0

        For Each student In Students
            If (student.Item1 = IIf(RButton_F.Checked, &quot;M&quot;, &quot;F&quot;)) Then Continue For
            sum += student.Item2
            num += 1
        Next student

        MsgBox(IIf(RButton_F.Checked, &quot;女&quot;, &quot;男&quot;) &amp; &quot;生的平均身高为&quot; &amp; (sum / num).ToString &amp; &quot;cm.&quot;)

    End Sub
End Class</pre>
<p>执行上述代码，所得之结果如下所示。当用户选择是要计算男生的平均身高还是女生的平均身高后，单击【确定】按钮，弹出的消息对话框就会给出相应的计算结果。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDQwMjUxNTQyNjY=.jpg" /></p>
<p><strong>五、Exit 语句</strong></p>
<p>Continue语句只能跳出当前正在执行的本轮循环，但是如果要退出整个循环过程就需要用到Exit语句。Exit语句的主要作用是跳出程序当前执行的程序结构块。跳出对象有For、While、Do、Sub、Function、Property、Select和Try等。Exit For就是跳出For循环的循环结构；Exit While就是跳出While循环的循环结构。其他情况与此类似。</p>
<p>下面来看一个例子。我们希望编写一个程序来判定用户输入的自然数是否是素数。素数是只能被1和其自身整除的数字。例如991是一个素数，通常我们要从2开始尝试，直到991折半取整，即495，检验从2到495之间的整数有否能够被991整除的，如果没有我们才能断定它确实是一个素数。但是对于一个非素数，例如1000，检验到2就已经可以确定它不是素数了。为了避免后续多余的计算，就需要使用Exit语句来跳出循环。</p>
<pre>Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim value As Integer
        Dim remainder As Integer
        Dim i As Integer
        Dim result As Boolean = False

        Try
            value = (TxtBox_Input.Text) / 2
        Catch ex As Exception
            MsgBox(&quot;请在文本框中输入一个正整数！&quot;, vbExclamation, &quot;提示&quot;)
            Return
        End Try

        For i = 2 To value
            remainder = TxtBox_Input.Text Mod i
            If remainder = 0 Then
                result = True
                Exit For
            End If
        Next
        MsgBox(&quot;整数&quot; &amp; TxtBox_Input.Text &amp; IIf(result, &quot;不是&quot;, &quot;是&quot;) &amp; &quot;素数！&quot;, vbInformation, &quot;判定结果&quot;)
    End sub
End Class</pre>
<p>执行上述代码，所得之结果如下所示。当用户输入一个素数，例如991时，程序弹出对话框给出该数是素数的结论。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDQxNDMxNDkwODU=.jpg" /></p>
<p>当用户输入一个非素数，例如327时，程序弹出对话框给出该数不是素数的结论。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDQxNDMxNTk1MDc=.jpg" /></p>
<p>就当前这个问题而言，我们其实还有另外一种实现方法，就是跳出整个Sub。事实上，这种方法在之前的示例中已经用过了。在 Sub 过程中，Return 语句等效于 Exit Sub。下面的示例代码中，Try...Catch块主要用来规避用户误输入所导致的问题（这个方法之前的例子也用过）。而在For循环中，也使用了Exit Sub，这与Try...Catch块中的Return是一样的。</p>
<pre>Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim value As Integer
        Dim remainder As Integer
        Dim i As Integer

        Try
            value = (TxtBox_Input.Text) / 2
        Catch ex As Exception
            MsgBox(&quot;请在文本框中输入一个正整数！&quot;, vbExclamation, &quot;提示&quot;)
            Return
        End Try

        For i = 2 To value
            remainder = TxtBox_Input.Text Mod i
            If remainder = 0 Then
                MsgBox(&quot;整数&quot; &amp; TxtBox_Input.Text &amp; &quot;不是素数！&quot;, vbInformation, &quot;判定结果&quot;)
                Exit Sub
            End If
        Next
        MsgBox(&quot;整数&quot; &amp; TxtBox_Input.Text &amp; &quot;是素数！&quot;, vbInformation, &quot;判定结果&quot;)

    End Sub
End Class</pre>
<p>上述代码的执行结果与前图所示一致，这里不再赘述。</p>
<p>*本文中所使用的Visual Studio版本为2013。</p>
<p><strong><br /></strong></p>
<p><strong>??（本文完）</strong></p>
<p>??</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 19:38:01 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/code/" title="code">code</a>, <a href="https://www.biecuoliao.com/tag/ima/" title="ima">ima</a>, <a href="https://www.biecuoliao.com/tag/string/" title="string">string</a>, <a href="https://www.biecuoliao.com/tag/tin/" title="tin">tin</a>, <a href="https://www.biecuoliao.com/tag/%e4%bf%a1%e6%81%af/" title="信息">信息</a>, <a href="https://www.biecuoliao.com/tag/car/" title="car">car</a>, <a href="https://www.biecuoliao.com/tag/static/" title="static">static</a>, <a href="https://www.biecuoliao.com/tag/until/" title="until">until</a>, <a href="https://www.biecuoliao.com/tag/%e5%af%b9%e8%b1%a1%e7%b1%bb%e5%9e%8b/" title="对象类型">对象类型</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Visual Basic快捷教程——流程控制的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Moxl7w0.html" rel="bookmark">Visual Basic快捷教程&mdash;&mdash;函数与子程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				函数是结构化程序设计的基础.可以拿现实生活中的&quot;社会分工&quot;这个概念来做类比.假设做包子只需要用到两种原料:一是用来做包子皮的面粉,另外就是用来做包子馅料的猪肉.作为一名专门做包子的厨师,你当然不能自己生产面粉和猪肉,所以你通常会从磨坊直接购买面粉,从肉铺直接购买猪肉.在这两种原料都具备的时候,你的任务仅仅只是负责做包子.更进一步,你还可以假设磨坊只负责把麦子磨成面粉,而不负责种植麦子,种植麦子的工作则有农民专门负责.对于做包子的厨师来说,他把生产面粉和猪肉这两项工作承包给了磨坊和肉铺,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Z1J7m0.html" rel="bookmark">GO語言基礎教程&colon;流程控制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在開始一個新的章節之前先來回顧上一篇文章的部份,首先我們來看這段代碼: package main import ( &quot;fmt&quot; ) func main(){ var x,y int=1,2 { var x int=2 { var x int=3 fmt.Println(x,y) //首先輸出3,2 如果我把這行輸出語句注解掉,大家猜猜會如何? } fmt.Println(x,y) //其次輸出2,2 } fmt.Println(x,y) //最後輸出1,2 } 執行結果我已經加到註釋內			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AeWmZ4.html" rel="bookmark">Visual&period;Basic程序设计教程&lpar;第四版&rpar;pdf</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下载地址:网盘下载 本书通过大量实例,深人浅出地介绍_厂Visual Basic 6.0中文版的开发环境.对象和事件驱动的概念.运算符和表达式.数据输入输出.常用标准控件.基本控制结构.数组和记录.过程调用.键盘和鼠标事件.菜单程序设计.对话框程序设计.多窗体程序设计以及文件处理等问题.针对初学者的特点,全书在编排上注意了由简及繁.由浅人深和循序渐进,力求通俗易懂.简捷实用.只要具有Windows初步知识,就可以通过本书掌握Visual Basic程序设汁的基本内容.全书每章都附有习题,便于学习			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NGWk2M.html" rel="bookmark">我与Visual Basic的那些事儿</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				公元2000年,IEEE计算机协会的一份期刊&lt;Computing in Science &amp; Engineering&gt;上,两位客座编辑Francis Sullivan和Jack Dongarra遴选出了20世纪科学与工程的实践与发展上最具影响力的十大算法[1].随后,Barry Cipra又在SIAM News上发表文章对这十大算法进行了综述[2].2016年,SIAM的主席Nick Higham对原来的十大算法列表进行了些许调整,并给出了自己的名单[3].两份名单在十大算法中的七项上基			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPwj9y4.html" rel="bookmark">Swift中文教程&lpar;三&rpar;--流程控制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:Swift中文教程(三)--流程控制 Swift用if和switch编写条件控制语句,用for-in,for,while和do-while编写循环.条件控制语句和循环语句中,小括号是可选的,但花括号包住这个循环体是必须的: 1 let individualScores = [75, 43, 103, 87, 12] 2 var teamScore = 0 3 for score in individualScores { 4 if score &gt; 50 { 5 teamScore += 3			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dKz9gM.html" rel="bookmark">Visual&period;Basic&period;6大学教程pdf</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下载地址:网盘下载 内容简介 编辑 本书深入浅出地介绍了Visual Basic 6语言的基本概念和编程技术,包括对象.属性.方法.语句.函数.结构等基本问题,以及面向对象编程.数据库管理和网络编程等高级课题.全书共分为21章,系统地讨论了Visual Basic 6的编程技巧及应用,并且提供了大量实用和有趣的实例和习题.读者通过学习本书,可以在较短时间内掌握基本的和最新的程序设计技术.本书所配的&quot;多媒体教室&quot;光盘更是独具特色,通过交互式环境,使学习过程更加生动有趣. 目录 编辑 第1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e2zyE3.html" rel="bookmark">Visual Basic程序设计应用教程&lpar;第2版&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下载地址:网盘下载 Visual Basic程序设计应用教程(第2版)是在第一版的基础上根据教育部计算机基础课程教学指导委员会制定的基本要求编写的.&lt;Visual Basic程序设计应用教程(第2版)&gt;以Visual Basic 60程序设计语言为工具,重点介绍了面向对象的程序设计语句.常用算法和编程思想,同时也介绍了Visual Basic的可视化界面设计应用技术,并以图文并茂的形式给出了大量的实例. &lt;Visual Basic程序设计应用教程(第2版)&gt;共分12章,第1章为Vi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4p8zWg4.html" rel="bookmark">云计算开发教程：Python自动化运维开发实战流程控制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天这篇文章是给大家分享一些云计算开发教程,今天讲解的是:Python自动化运维开发实战流程控制. Python条件语句是通过一条或多条语句的执行结果(True或者False)来决定执行的代码块. Python程序语言指定任何非0和非空(null)值为true,0 或者 null为false. if 语句用于控制程序的执行,基本形式为: if 判断条件: 执行语句-- else: 执行语句-- 其中&quot;判断条件&quot;成立时(非零),则执行后面的语句,而执行内容可以多行,以缩进来区分表示同一范			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXrneb3.html" rel="bookmark">Shell入门教程：流程控制（1）命令的结束状态</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Bash Shell中,流程控制命令有2大类:“条件”.“循环”.属于“条件”的有:if.case:属于“循环”的有:for.while.until:命令 select 既属于“条件”,也属于“循环”.不管是哪一种,均需进行条件测试,再根据测试结果,决定程序流程进行的方向. 以下逐一说明这些命令的用法. 第一节:命令的结束状态 Bash Shell Script 可由许多命令组成.每一个命令执行后,都会传回一个结束状态值,如果执行成功,传回0,如果执行失败,则传回非0值.执行失败,也分成许多状			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j4NGJZM.html" rel="bookmark" class="title">ZooKeeper架构设计及其应用要点</a>
					<div>
						ZooKeeper是一个开源的分布式服务框架,它是Apache Hadoop项目的一个子项目,主要用来解决分布式应用场景中存在的一些问题,如:统一命名服务.状态同步服务.集群管理.分布式应用配置管理等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/D3Oo8g3.html" rel="bookmark" class="title">2016&sol;12&sol;30&lowbar;Python</a>
					<div>
						今天主要学习内容: Python: 1.字典的使用 1)怎么创建字典 dicts = {&quot;name&quot;:&quot;juncx&quot;,&quot;age&quot;:17} d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38NorRM.html" rel="bookmark" class="title">C&num;之Attribute（特性）</a>
					<div>
						本文主要复习下基础知识: 1.C#系统自带的特性: 建立一个控制台项目取名为AttributeTest: 我们添加了一个系统自带的Attribute叫Condition,这个特性表示在程序的DEBUG ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWy2Rm3.html" rel="bookmark" class="title">ubuntu下安装nodejs</a>
					<div>
						一.确保你的ubuntu安装了依赖包和 python,gcc,g++组件以及可选的git组件,部分可能会在更新源中已经安装.如果没有则要重新安装,命令如下: $ sudo apt-get instal ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXY6jz0.html" rel="bookmark" class="title">HDU 1520 Anniversary party &lpar;树形DP&rpar;</a>
					<div>
						树形DP的关键在于如何处理递归返回的信息.这题dp[i][0]表示不选i点时当前最高权值.dp[i][1]表示选i点时当前最高权值.状态转移方程:dp[u][[0]+=max(dp[v][0],dp[ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6NpLdM.html" rel="bookmark" class="title">HTTP响应状态码</a>
					<div>
						常见的http响应状态码 http状态返回代码 1xx(临时响应) 表示临时响应并需要请求者继续执行操作的状态代码 100    (继续) 请求者应当继续提出请求 服务器返回此代码表示已收到请求的第一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YGlxw4.html" rel="bookmark" class="title">awesome-nlp</a>
					<div>
						awesome-nlp  A curated list of resources dedicated to Natural Language Processing Maintainers - Keon ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVw9ww0.html" rel="bookmark" class="title">简单的文件同步备份程序，仅支持单向同步&lowbar;程序及源代码</a>
					<div>
						1. 程序 http://files.cnblogs.com/files/fjwuyongzhi/FileSync.zip 2. 源代码 http://files.cnblogs.com/files/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JkQxBM.html" rel="bookmark" class="title">文本特效</a>
					<div>
						1.滚动文本 &lt;!--单行,溢出滚动,获得光标,滚动无限次--&gt; android:singleLine=&quot;true&quot; android:ellipsize=&quot;m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2Gxa3.html" rel="bookmark" class="title">java设计优化--代理模式</a>
					<div>
						代理模式使用代理对象完成用户的请求,屏蔽用户对真实对象的访问. 代理模式的用途很多,比如因为安全原因,需要屏蔽客户端直接访问真实对象:或者在远程调用中,需要使用代理对象处理远程方法中的技术细节:或者为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGvGPM.html" rel="bookmark" class="title">创建存储过程和函数【weber出品必属精品】</a>
					<div>
						一.什么是存储过程和函数 1. 是被命名的pl/sql块 2. 被称之为pl/sql子程序 3. 与匿名块类似,有块结构: 声明部分是可选的(没有declare关键字) 必须有执行部分 可选的异常处理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLja1B3.html" rel="bookmark" class="title">Linux第三天</a>
					<div>
						第三天        vi编辑器 一     vi编辑器简介 vim           全屏幕纯文本编辑器 二     vim使用 1      vim  三种模式 vim  文件名 命令模式 输入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qvqYN4.html" rel="bookmark" class="title">采用TCP协议的PIC32MZ ethernet bootloader</a>
					<div>
						趁热打铁,在上一PIC32MZ UDP ethernet bootloader的基础上我又完成了采用TCP协议的PIC32MZ ethernet bootloader.两款ethernet bootl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NaBkB3.html" rel="bookmark" class="title">PropertySource的配置</a>
					<div>
						PropertySource的配置. Spring3.1引入了一种方法, 即使用下面这两个注解, @PropertySource和@Value, 可以用很简单的方式注意一个bean的属性. 1 @Pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e7jOp4.html" rel="bookmark" class="title">插入排序C语言实现</a>
					<div>
						插入排序可是说是最简单的排序算法之一了,时间复杂度是O(N^2),下面是C语言实现 void insertion_sort(int *A, int n) { int i, j, x; //i从1开始而 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmokPK3.html" rel="bookmark" class="title">&amp;lt&semi;转&amp;gt&semi;函数重载之const</a>
					<div>
						函数重载之const 2012-03-10 10:17:17|  分类: C/C++学习笔记|举报|字号 订阅 我们知道,如果函数名相同,在相同的作用域内,其参数类型.参数个数,参数顺序不同等能构成函 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MymPbpM.html" rel="bookmark" class="title">mysql中表名是order的CRUD的错误</a>
					<div>
						org.springframework.jdbc.BadSqlGrammarException: ### Error querying database. Cause: com.mysql.jdbc. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3On7DZ0.html" rel="bookmark" class="title">巳萝送峡啬j1xo22u45u4mi2</a>
					<div>
						http://bbs.feng.com/home.php?mod=space&amp;uid=10025943http://www.imaibo.net/longweibo/detail/55ba33 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OnR190.html" rel="bookmark" class="title">ViewState是什么</a>
					<div>
						在做ASP.NET的时候遇到ViewState,当时不知道他是什么意思. 就在当前页面中保存数据的. 像session.是会话级别的.只要会话没有过期.session中存的数据就在. viewstat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47ePvo0.html" rel="bookmark" class="title">Node&period;js开发入门&mdash;使用AngularJS</a>
					<div>
						做一个Web应用,一般都有前台和后台,Node.js可以实现后台,利用jade模板引擎也可以生成一些简单的前台页面,但要想开发出具有实际意义的现代Web应用,还得搭配一个Web前端框架. Angula ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
